; ***********************************************************************************
; * Name		:	G. Mayer 														*
; * Customer	:	Gong fr Puppenhaus												*
; * Datum		:	30.05.2014														*
; * 																				*
; * nderungen	:																	*
; *					V01 Erstellung									30.05.2014		*
; *																					*
; *  2014 dazkeiler.de																*
; ***********************************************************************************

; ***********************************************************************************
; * Fuses:																			*
; *																					*
; * SELFPRGEN	:	yes -> nach einlernen no										*
; * RSTDISBL	:	no																*
; * DWEN		:	no																*
; * SPIEN		:	yes																*
; * WTDON		:	yes																*
; * EESAVE		:	no																*
; * BODLEVEL	:	Brown-out detection disabled									*
; * CKDIV8		:	no																*
; * CKOUT		:	no																*
; * SUT_CKSEL	:	Ext. C-Osc.8MHz; Start-up time PWRDWN/RESET: 16K CK/14 CK+65ms	*
; *																					*
; *	HIGH		:	CF																*
; * LOW			:	FF																*
; * EXTENDED	:	FF																*
; ***********************************************************************************

.include "tn24adef.inc"

; ***********************************************************************************
; * Konstanten																		*
; ***********************************************************************************
.equ K_TimeIntervallPWM						= 50		; *1s = 50s
.equ K_TimeIntervall10ms					= 10000		; *1s = 10ms
.equ K_TimeIntervall100ms					= 10		; *10ms = 100ms
.equ BaseTime 								= 24		; Speed

; ***********************************************************************************
; * Register Zuweisungen															*
; ***********************************************************************************
.def R_TABVAL				= 	R0						;
;.def Stsave				= 	R1						;
.def R_SUM1					=	R2						;
.def R_SUM2					=	R3						;
.def R_SUM3					=	R4						;
.def R_SUM4					=	R5						;
.def R_ZRegL				=	R6						;
.def R_ZRegH				=	R7						;
;.def xXx					=	R8						;
;.def xXx					=	R9						;
;.def xXx					=	R10						;
;.def xXx					=	R11						;
;.def xXx					=	R12						;
;.def xXx					=	R13						;
;.def xXx					=	R14						;
;.def xXx					=	R15						;
;.def xXx					=	R15						;
;.def Temp					=	R16						; 
.def R_FLAG					=	R17						; 				
.def R_TON					= 	R18						;
.def R_SoundEN				=	R19						; 
.def R_TWait				=   R20						; 
.def R_TP2					=   R21						; 
.def R_TP3					=   R22						; 
;.def xXx					=	R23						; 
.def R_Prescaler100ms		=	R24						; 
.def R_STATUS				=	R25						; STATUS Register
	; *******************************************************************************
	; *	STATUS Flags																*
	; *******************************************************************************
	.equ F_10ms				= 	0						; Flag fr 10ms
	.equ F_100ms			= 	1

; ***********************************************************************************
; * Reservierte Register															*
; ***********************************************************************************
;.def XL					=	R26						; Freihalten
;.def XH					=	R27						; Freihalten
;.def YL					=	R28						; Freihalten
;.def YH					=	R29						; Freihalten
;.def ZL					=	R30						; Freihalten
;.def ZH					=	R31						; Freihalten

; ***********************************************************************************
; * RAM Bereich 																	*
; ***********************************************************************************
.dseg
RAM_TastenCode:					.byte 1
RAM_MyEnd:						.byte 1

; ***********************************************************************************
; * Port Zuweisungen Port A															*
; ***********************************************************************************
.equ SWPort					= 	PinA
.equ HEX1Port				=	PinA					; 
.equ HEX1					=	0		
.equ HEX2Port				=	PinA					; 
.equ HEX2					=	1
;.equ xXxPort				=	PinA					; 
;.equ xXx					=	2
.equ KeyPort				=	PinA					; 
.equ Key					=	3
;.equ xXxPort				=	PinA					;
;.equ xXx					=	4
;.equ xXxPort				= 	PinA					;
;.equ xXx					= 	5
;.equ xXxPort				=	PortA
;.equ xXx					=	6
.equ SpeakerPort			=	PortA					;
.equ Speaker				=	7

; ***********************************************************************************
; * Port Zuweisungen Port B															*
; ***********************************************************************************
;.equ xXxPort				= 	PortB	; 
;.equ xXx					= 	0							
;.equ xXxPort				= 	PortB	; 
;.equ xXx					= 	1
;.equ xXxPort				=	PinB
;.equ xXx					=	2						
;.equ RESETPort				= 	PortB
;.equ RESET					= 	3


; ***********************************************************************************
; * Initialization	/ Address Labels Code Comments									*
; ***********************************************************************************
.cseg
	rjmp RESET 											; Reset Handler
	rjmp EXT_INT0_INT 									; IRQ0 Handler
	rjmp PCINT0_INT 									; PCINT0 Handler
	rjmp PCINT1_INT 									; PCINT1 Handler
	rjmp WATCHDOG_INT 									; Watchdog Interrupt Handler
	rjmp TIM1_CAPT										; Timer1 Capture Handler 
	rjmp TIM1_COMPA_INT 								; Timer1 CompareA Handler
	rjmp TIM1_COMPB_INT 								; Timer1 CompareB Handler
	rjmp TIM1_OVF_INT 									; Timer1 Overflow Handler
	rjmp TIM0_COMPA_INT 								; Timer0 CompareA Handler
	rjmp TIM0_COMPB_INT 								; Timer0 CompareB Handler
	rjmp TIM0_OVF_INT 									; Timer0 Overflow Handler
	rjmp ANA_COMP_INT 									; Analog Comparator Handler
	rjmp ADC_INT 										; ADC Conversion Handler
	rjmp EE_RDY_INT 									; EEPROM Ready Handler
	rjmp USI_START										; USI Interrupt Handler
	rjmp USI_OVF										; USI Overflow Handler

; ***********************************************************************************
; * Reset Handler																	*
; ***********************************************************************************
RESET: 	
	ldi 	XL,Low(RAMEND)								; Hauptprogramm Start
	out 	SPL,XL 										; Stack Pointer auf ersten RAM Platz setzen	
	
	wdr													; reset watchdog
	ldi		XL,0b00011000								; watchdog change enable
	out		WDTCSR,XL
	ldi		XL,0b00011011								; watchdog prescal set to 125ms
	out		WDTCSR,XL
	ldi		XL,0b00001011								; watchdog change disable
	out		WDTCSR,XL
	wdr
	
; ***********************************************************************************
; * Port Deklarationen Port A														*
; ***********************************************************************************
	ldi		XH,0b00001011		; PORTA					; PullUp 	: 0 -> Nein	, 1 -> Ja
	ldi		XL,0b10000000		; DDRA	 				; Richtung 	: 0 -> Input, 1 -> Output
;                ||||||||
;                |||||||+- 0    - SW0			 		; (input PullUp)
;                ||||||+-- 1    - SW1					; (input PullUp)
;                |||||+--- 2    - HEX2					; (input)
;                ||||+---- 3    - Taster				; (input PullUp)
;                |||+----- 4    - SCK					; (input)
;                ||+------ 5    - MISO					; (input)
;                |+------- 6    - MOSI					; (input)
;                +-------- 7  	- Speaker				; (output)
	out		PortA,XH              
	out		DDRA,XL					

; ***********************************************************************************
; * Port Deklarationen Port B														*
; ***********************************************************************************
	ldi		XH,0b00000000		; PORTB					; PullUp 	: 0 -> Nein	, 1 -> Ja
	ldi		XL,0b00000000		; DDRB	 				; Richtung 	: 0 -> Input, 1 -> Output
;                ||||||||
;                |||||||+- 0    - NC		 			; (input)
;                ||||||+-- 1    - NC					; (input)
;                |||||+--- 2    - NC					; (input)
;                ||||+---- 3    - RESET 				; (input)
;                |||+----- 4    - nicht Rausgefhrt
;                ||+------ 5    - nicht Rausgefhrt
;                |+------- 6    - nicht Rausgefhrt
;                +-------- 7	- nicht Rausgefhrt
	out		PortB,XH
	out		DDRB,XL

; ***********************************************************************************
; * Takt / 1 (8MHz / 1 = 8MHz)														*
; ***********************************************************************************
;	ldi		XL,0b10000000								; Entsperren des CLKPR Register fr nderungen
;	out		CLKPR,XL
;	ldi		XL,0b00000000								; Clock / 2 = 4Mhz
;	out		CLKPR,XL

; ***********************************************************************************
; * Configure Timer0																*
; * Clock Select fr Timer0 / 64 = 1Tick 											*
; ***********************************************************************************
	ldi		XL,0b00000000	;	  TCCR0A
	ldi		XH,0b00000011	;					TCCR0B
;                ||||||||
;                |||||||+- 0    - WGM00		/	CS00	
;                ||||||+-- 1    - WGM01		/	CS01
;                |||||+--- 2    - *			/	CS02
;                ||||+---- 3    - *			/	WGM02
;                |||+----- 4    - COM0B0	/	WGM03
;                ||+------ 5    - COM0B1	/	*
;                |+------- 6    - COM0A0	/	FOC0B
;                +-------- 7    - COM0A1	/	FOC0A
	out		TCCR0A,XL
	out		TCCR0B,XH

; ***********************************************************************************
; * TIMSK0																			*
; ***********************************************************************************
;	in		XL,TIMSK0
	ldi 	XL,0b00000001
;                ||||||||
;                |||||||+- 0    - TOIE0
;                ||||||+-- 1    - OCIE0A
;                |||||+--- 2    - OCIE0B
;                ||||+---- 3    - *
;                |||+----- 4    - *
;                ||+------ 5    - *
;                |+------- 6    - *
;                +-------- 7    - *
	out		TIMSK0,XL

; ***********************************************************************************
; * Configure Timer1																*
; * Clock Select fr Timer1 / 8 = 1Tick 1s and ICP									*
; ***********************************************************************************
	ldi		XL,0b00000000	;	  TCCR1A
	ldi		XH,0b00000010	;					TCCR1B
;                ||||||||
;                |||||||+- 0    - WGM10		/	CS10	
;                ||||||+-- 1    - WGM11		/	CS11
;                |||||+--- 2    - *			/	CS12
;                ||||+---- 3    - *			/	WGM12
;                |||+----- 4    - COM1B0	/	WGM13
;                ||+------ 5    - COM1B1	/	*
;                |+------- 6    - COM1A0	/	ICES1
;                +-------- 7    - COM1A1	/	ICNC1
	out		TCCR1A,XL
	out		TCCR1B,XH
		
; ***********************************************************************************
; * TIMSK1																			*
; ***********************************************************************************
;	in		XL,TIMSK1
	ldi 	XL,0b00000010
;                ||||||||
;                |||||||+- 0    - TOIE1
;                ||||||+-- 1    - OCIE1A
;                |||||+--- 2    - OCIE1B
;                ||||+---- 3    - *
;                |||+----- 4    - *
;                ||+------ 5    - ICIE1
;                |+------- 6    - *
;                +-------- 7    - *
	out		TIMSK1,XL

; ***********************************************************************************
; * MCUCR Config																	*
; ***********************************************************************************
	ldi		XL,0b00100000
;                ||||||||
;                |||||||+- 0  	- ISC00
;                ||||||+-- 1    - ISC01
;                |||||+--- 2    - BODSE
;                ||||+---- 3    - SM0
;                |||+----- 4    - SM1
;                ||+------ 5    - Sleep Enable = 1
;                |+------- 6    - PUD
;                +-------- 7    - BODS
	out		MCUCR,XL

; ***********************************************************************************
; * GIMSK Config																	*
; ***********************************************************************************
	ldi		XL,0b00010000
;                ||||||||
;                |||||||+- 0	- unused
;                ||||||+-- 1    - unused
;                |||||+--- 2    - unused
;                ||||+---- 3    - unused
;                |||+----- 4    - PCIE0 Pin Change Interrut PCINT7..0  Enable = 1
;                ||+------ 5    - PCIE1 Pin Change Interrut PCINT8..11 Enable = 1
;                |+------- 6    - INT0
;                +-------- 7    - unused
	out		GIMSK,XL

; ***********************************************************************************
; * PCMSK0-1 Config	- Pin Change Interrupt "PCINT0-11" Konfiguration				*
; ***********************************************************************************
	ldi		XH,0b00000000 ;-----> PCMSK0 
	ldi		XL,0b00000001 ;-----------------> PCMSK1
;                ||||||||
;                |||||||+- 0  	- PCINT0 	/ PCINT8
;                ||||||+-- 1    - PCINT1 	/ PCINT9
;                |||||+--- 2    - PCINT2 	/ PCINT10
;                ||||+---- 3    - PCINT3 	/ PCINT11
;                |||+----- 4    - PCINT4
;                ||+------ 5    - PCINT5
;                |+------- 6    - PCINT6
;                +-------- 7    - PCINT7
	out		PCMSK0,XH
	out		PCMSK1,XL

; ***********************************************************************************
; * Initialisierungen																*
; ***********************************************************************************
Init:
	rcall	InitRAMAndReg
	clr		R_STATUS

;**** Summe mit 0 Initialisieren
	clr 	R_SUM1
	clr 	R_SUM2
	clr 	R_SUM3
	clr 	R_SUM4

;**** Sound am Anfang disablen
    ldi 	R_SoundEN,0

;**** Flag Setzen
    ser 	R_FLAG        								; Alle Bits auf 1

	sei													; Alle Interrupts freischalten

; ***********************************************************************************
; *					 																*
; *									Hauptprogramm									*
; *																					*
; ***********************************************************************************
MainLoop:
	wdr
	sleep

;	in		XL,SWPort
;	andi	XL,0b00000100
	sbis	KeyPort,Key
	rcall	PlaySound	
	rjmp	MainLoop

/*
MainLoop:
	wdr
	sleep

	sbrs	R_STATUS,F_10ms								; kommt alle 10ms
	rjmp	MainLoop

	; ***************
	; * 10ms		*
	; ***************	
	cbr		R_STATUS,(1<<F_10ms) 						; clear 10ms Flag
	rcall	Task10ms

	sbrs	R_STATUS,F_100ms							; kommt alle 10ms
	rjmp	MainLoop

	; ***************
	; * 100ms		*
	; ***************
	cbr		R_STATUS,(1<<F_100ms)	 					; clear 100ms Flag
	rcall	Task100ms

MainLoop_End:
	rjmp	MainLoop
*/

; ***********************************************************************************
; *					 																*
; *									Unterprogramme									*
; *																					*
; ***********************************************************************************

; ***********************************************************************************
; * 10ms Task																		*
; ***********************************************************************************
Task10ms:
Task10ms_End:
	ret

; ***********************************************************************************
; * 100ms Task																		*
; ***********************************************************************************
Task100ms:
Task100ms_End:
	ret

; ***********************************************************************************
; * Include Files																	*
; ***********************************************************************************
.include "modLibV01.asm"

; ***********************************************************************************
; *					 																*
; *								Interupt Einsprnge									*
; *																					*
; ***********************************************************************************

; ***********************************************************************************
; * Interrupt fr 10ms Task															*
; ***********************************************************************************
TIM1_COMPA_INT:
	push	XH
	in		XH,SREG
	push	XL
	push	XH
	push	YL
	push	YH
	push	ZL
	push	ZH

	in		XL,OCR1AL
	in		XH,OCR1AH
	ldi		YL,Low(K_TimeIntervall10ms)
	ldi		YH,High(K_TimeIntervall10ms)
	add		XL,YL
	adc		XH,YH
	out		OCR1AH,XH
	out		OCR1AL,XL
	sbr		R_STATUS,(1<<F_10ms) 						; set 10ms Flag

	dec		R_Prescaler100ms
	brne	TIM1_COMPA_INT_End

	ldi		R_Prescaler100ms,K_TimeIntervall100ms
	sbr		R_STATUS,(1<<F_100ms) 						; set 100ms Flag

TIM1_COMPA_INT_End:
	pop		ZH
	pop		ZL
	pop		YH
	pop		YL
	pop		XH
	pop		XL
	out		SREG,XH
	pop		XH
	reti

; ***********************************************************************************
; * Timer Interrupt-Routine															*
; ***********************************************************************************
TIM0_OVF_INT:
	push	XH
	in		XH,SREG
	push	XL
	push	XH
	push	YL
	push	YH
	push	ZL
	push	ZH

	out 	TCNT0,R_TON
	mov 	XL,R_TON       								; Anzahl der Zhlercounts summieren
	com 	XL            								; in 32 Bit sum1-sum4
	add 	R_SUM1,XL
	clr 	XL
	adc 	R_SUM2,XL
	adc 	R_SUM3,XL
	adc 	R_SUM4,XL
    cpi 	R_SoundEN,0x01  							; Sound-Ausgabe erlaubt ?
	brne 	TIM0_OVF_INT_SpeakerOff
	
	;sbi 	PINA,PA0

 	com 	R_FLAG            							; Invertieren
	brne 	TIM0_OVF_INT_SpeakerOff

	sbi 	SpeakerPort,Speaker
	rjmp 	TIM0_OVF_INT_End

TIM0_OVF_INT_SpeakerOff:
	cbi		SpeakerPort,Speaker

TIM0_OVF_INT_End:
	pop		ZH
	pop		ZL
	pop		YH
	pop		YL
	pop		XH
	pop		XL
	out		SREG,XH
	pop		XH
    reti

EXT_INT0_INT:											; IRQ0 Handler
PCINT0_INT: 											; PCINT0 Handler
PCINT1_INT: 											; PCINT1 Handler
WATCHDOG_INT: 											; Watchdog Interrupt Handler
TIM1_CAPT:												; Timer1 Capture Handler 
;TIM1_COMPA_INT: 										; Timer1 CompareA Handler
TIM1_COMPB_INT: 										; Timer1 CompareB Handler
TIM1_OVF_INT: 											; Timer1 Overflow Handler
TIM0_COMPA_INT: 										; Timer0 CompareA Handler
TIM0_COMPB_INT: 										; Timer0 CompareB Handler
;TIM0_OVF_INT:											; Timer0 Overflow Handler
ANA_COMP_INT: 											; Analog Comparator Handler
ADC_INT: 												; ADC Conversion Handler
EE_RDY_INT: 											; EEPROM Ready Handler
USI_START:												; USI Interrupt Handler
USI_OVF:												; USI Overflow Handler
	reti;

; ***********************************************************************************
; *	FLASH Area																		*
; ***********************************************************************************

; ***********************************************************************************
; *	Frequenz Tabelle																*
; ***********************************************************************************
TONFRQ:
    .dw 0x8911  		; 0 17, 137 - C
	.dw 0x8f1f  		; 1 31, 143 - Cis
	.dw 0x962b  		; 2 43, 150 - D
    .dw 0x9c37  		; 3 55, 156 - Dis
	.dw 0xa142  		; 4 66, 161 - E
	.dw 0xa74d  		; 5 77, 167 - F
	.dw 0xac57  		; 6 87, 172 - Fis
	.dw 0xb061  		; 7 97, 176 - G
	.dw 0xb56a  		; 8 106,181 - Gis
	.dw 0xb972  		; 9 114,185 - A
	.dw 0xbd7a  		; A 122,189 - Ais
	.dw 0xc181  		; B 129,193 - H

; ***********************************************************************************
; *	Ton Tabelle																		*
; *																					*
; *	 Highbyte  Lowbyte																*
; *	-------------------																*
; *	0000 0000 0000 0000																*
; *	|      || |  | |__|------	0-11 = 12 Halbtne									*
; *	|      || |__|-----------	1/2  = Octaven										*
; *	|      ||----------------	0=Ton, 1=Pause										*
; *	|______|-----------------	1-127 = Dauer										*
; *																					*
; ***********************************************************************************
TAB_Sound01:			; Kein Sound
	.dw 0

TAB_Sound02:			; BigBen
	.dw 0x1014
	.dw 0x1018
	.dw 0x1016
	.dw 0x3C0b
	.dw 0x1014
	.dw 0x1016
	.dw 0x1018
	.dw 0x3C14
	.dw 0x1018
	.dw 0x1014
	.dw 0x1016
	.dw 0x3C0b
	.dw 0x100b
	.dw 0x1016
	.dw 0x1018
	.dw 0x3C14
	.dw 0

TAB_Sound03:			; Dakapo
    .dw 0x1000
	.dw 0x1004
	.dw 0x1007  		; Z1 T1
	.dw 0x3010  		;    T2
	.dw 0x3012  		;    T3
	.dw 0x100b
	.dw 0x1009
	.dw 0x1007  		;    T4
	.dw 0x1809
	.dw 0x080b
	.dw 0x1009  		;    T5
	.dw 0x2007
	.dw 0x1100  		; Z2 T1
	.dw 0x1000
	.dw 0x1002
	.dw 0x1004  		;    T2
	.dw 0x3007  		;    T3
	.dw 0x3009  		;    T4
	.dw 0x1807
	.dw 0x0802
	.dw 0x1002  		;    T5
	.dw 0x4002
	.dw 0x2100  		; Z3 T1+2
	.dw 0x1007
	.dw 0x1004
	.dw 0x1007 			;     T3
	.dw 0x3010 			;     T4
	.dw 0x3009 			;     T5
	.dw 0x1007
	.dw 0x1004
	.dw 0x1000 			; Z4  T1
	.dw 0x3000 			;     T2
	.dw 0x3002 			;     T3
	.dw 0x1004
	.dw 0x1002
	.dw 0x1004 			;     T4
	.dw 0x3007 			; Z5  T1
	.dw 0x3009 			;     T2
	.dw 0x1002
	.dw 0x1804
	.dw 0x0802 			;     T3
	.dw 0x4000
	.dw 0x2100 			;     T4+5
	.dw 0x3100 			; noch ein Takt Pause und dann Dakapo
	.dw 0

TAB_Sound04:			; Jej czarne oczy
;	.dw 0x0804			; 1
;	.dw 0x0807			; 2
;	.dw 0x2409			; 3
;	.dw 0x1009
;	.dw 0x0900			; Pause 
	.dw 0x0804			; 1
	.dw 0x0807			; 2
	.dw 0x0809			; 3
	.dw 0x0810			; 4
	.dw 0x0810			; 5
	.dw 0x080B			; 6
	.dw 0x1009			; 7
;	.dw 0x0809			; 8
	.dw 0x0810			; 9
	.dw 0x0812			; 10
	.dw 0x1014			; 11
;	.dw 0x0814			; 12
	.dw 0x0814			; 13
	.dw 0x0812			; 14
	.dw 0x1010			; 15
;	.dw 0x0810			; 16
	.dw 0x0814			; 17
	.dw 0x1012			; 18
;	.dw 0x0812			; 19
	.dw 0x0812			; 20
	.dw 0x0810			; 21
	.dw 0x100B			; 22
;	.dw 0x080B			; 23
	.dw 0x0810			; 24
	.dw 0x080B			; 25
	.dw 0x3409			; 26
;	.dw 0x1009

	.dw 0x0900			; Pause 
	.dw 0x0804			; 1
	.dw 0x0807			; 2
	.dw 0x0809			; 3
	.dw 0x0810			; 4
	.dw 0x0810			; 5
	.dw 0x080B			; 6
	.dw 0x1009			; 7
;	.dw 0x0809			; 8
	.dw 0x0810			; 9
	.dw 0x0812			; 10
	.dw 0x1014			; 11
;	.dw 0x0814			; 12
	.dw 0x0814			; 13
	.dw 0x0812			; 14
	.dw 0x1010			; 15
;	.dw 0x0810			; 16
	.dw 0x0814			; 17
	.dw 0x1012			; 18
;	.dw 0x0812			; 19
	.dw 0x0812			; 20
	.dw 0x0810			; 21
	.dw 0x100B			; 22
;	.dw 0x080B			; 23
	.dw 0x0810			; 24
	.dw 0x080B			; 25
	.dw 0x3409			; 26
;	.dw 0x1009
	.dw 0

; ***********************************************************************************
; *	RAM Area																		*
; ***********************************************************************************
.dseg

; ***********************************************************************************
; * EEPROM Area																		*
; ***********************************************************************************
.eseg



